#ifndef MOSESPARTICLE_h
#define MOSESPARTICLE_h
/*********************************************/
/* class to set new particle properties.     */
/* these are being added to the PDT particle */
/* properties in a new struct with the first */
/* member as pdtParticle struct              */
/*********************************************/
//----------------
#include "Moses.h"
//----------------

using namespace std;

namespace Moses1 {


struct customParticle {

	pdtParticle pdt_prt; // put here first the PDT particle properties struct !!!
	
	// then add custom features !!!
	double weakIsospin; // can be anything. for example: weakIsospin -> u(I)=1/2, d(I)=1/2
	double weakI3; // for example: weakI3
	int Nc; // for example: number of colors (leptons: Nc= 1, quarks: Nc = 3)
	// double extraproperty1;
	// string extraproperty2;
	// int extraproperty3;
	// etc...
};


class CUSTOMparticle {
	public:
		// preferably - this is not to use
		CUSTOMparticle();
		virtual ~CUSTOMparticle();

		// fill a SINGLE customParticle struct from PDT particle struct and then add features manually.
		// put all into the sulpplied struct.
		virtual void setCUSTOMparticle(pdtParticle &pdt_particle, customParticle &custom_particle);

		// fill ALL customParticle struct from PDT particle vector of struct and then add features manually.
		// put all into the sulpplied vector.
		virtual void setCUSTOMparticle(vector<pdtParticle> &pdt_particle, vector<customParticle> &custom_particle);

};

}
#endif

