#ifndef PARAMETERS_h
#define PARAMETERS_h
/**************************************/
/*  class of user defined parameters  */
/**************************************/
//----------------
#include "Moses.h"
//----------------

using namespace std;

namespace Moses1 {

struct physicalParameters { // a structure to contain all user defined physycal parameters
	double sinThetaW2;
	double cosThetaW2;
	double pi;
	double alpha;
	double gQCD;
        double g_mGluonStar;
	double Gmu;
	double mStar;
	double mZprime;
        double wZprime;
	double mGluonStar;
	//dcomplex i;
	dcomplex i;
	double GeV2mbarn;
	double GeV2nbarn;
	//.
	//.
	//.
};

struct runParameters{ // a structure to contain all user defined run parameters
	double sMax;
	int nEvents;
	double luminosity;
	double pTCut, etaCut, invMassCut;
	double pTsystemCut, ySystemCut;
	//.
	//.
};

class parameters {
	public:
		// constructor initializes all fixed parameters in 2 different ways:
		parameters(); // initialize with a single parameters struct
		virtual ~parameters();
		virtual void setParameters(physicalParameters &physPrm); // initialize physical parameters struct
		virtual void setParameters(runParameters &runPrm); // initialize run parameters struct (overload)
		virtual void printUnits(void); // print the conversion units
	private:
		physicalParameters m_physPrm; // physical parameters struct
		runParameters m_runPrm; // physical parameters struct
};

}
#endif

