/************************************************************/
/* class to evaluate the user defined width                 */
/* the function here is taken from the "Z LINE SHAPE" paper */
/************************************************************/
#include "smearing.h"
using namespace std;

namespace Moses1 {

smearing::smearing(){}

smearing::~smearing(){}


void smearing::settings(double average, double sigma, double resolution, double pTTrackScale) // avreage=0., sigma=1., resolution=0.12, pTTrackScale=1.e-3
{
	m_average    = average;
        m_sigma      = sigma;
        m_resolution = resolution;
        m_pTTrackScale = pTTrackScale;
        gaussGenerator = new TRandom();
}

double smearing::gaussRand() // must be called after smearing::settings
{
	m_gaussRand = gaussGenerator->Gaus(/*double mean = */m_average, /*double sigma = */m_sigma); // the random number ???
	return m_gaussRand;
}

double smearing::pTsmear(double pT)
{
	m_pTSmeared = 1./(1./pT + gaussRand()*m_resolution/m_pTTrackScale);
	return m_pTSmeared;
}

double smearing::pT2px(double pTsmeared, double phi)
{
	m_pxSmeared = pTsmeared*cos(phi);
	return m_pxSmeared;	
}

double smearing::pT2py(double pTsmeared, double phi)
{
	m_pySmeared = pTsmeared*sin(phi);
	return m_pySmeared;
}

double smearing::pT2pz(double pTsmeared, double theta)
{
	m_pzSmeared = pTsmeared/tan(theta);
	return m_pzSmeared;
}

double smearing::pT2e(double pTsmeared,  double theta)
{
	m_eSmeared = pTsmeared/sin(theta);
	return m_eSmeared;
}

void   smearing::compare2true(double pxOrig, double pyOrig, double pzOrig, double eOrig)
{
	cout << "(pxS/px0 - 1)% = " << (m_pxSmeared/pxOrig - 1.)*100 << endl;
	cout << "(pyS/py0 - 1)% = " << (m_pySmeared/pyOrig - 1.)*100 << endl;
	cout << "(pzS/pz0 - 1)% = " << (m_pzSmeared/pzOrig - 1.)*100 << endl;
	cout << "(eS/e0 - 1)%   = " << (m_eSmeared/eOrig - 1.)*100 << "\n" << endl;
}


}

