#ifndef MOSESCOMMON_h
#define MOSESCOMMON_h
/**********************************/
/* a class for general operations */
/**********************************/
//---------------------- std
#include <iostream>
#include <stdlib.h>
#include <stdio.h>	// for the sprintf call
#include <string>
#include <sstream>	// for the int to string operation (stringstream call)
#include <cstring>	// for the string functions
#include <math.h>
#include <cmath>
#include <complex>
#include <fstream>
#include <vector>
#include <map>
//----------------------- ROOT (probably not all necessary)
#include <TROOT.h>
#include <TSystem.h>
#include <TH1.h>
#include <TH2.h>
#include <TFile.h>
#include <TMath.h>
#include <TF1.h>
#include <TF2.h>
#include <TH1D.h>
#include <TH2D.h>
#include <TProfile.h>
#include <TKey.h>
#include <TTree.h>
#include <TCanvas.h>
#include <TAttFill.h>
#include <TVirtualPad.h>
#include <Gtypes.h>
#include <TGraph.h>
#include <TGraphErrors.h>
#include <TMultiGraph.h>
#include <TLegend.h>
#include <TPaveStats.h>
#include <TStyle.h>
#include <TBrowser.h>
#include <TApplication.h>
#include <TMinuit.h>
#include <TPaletteAxis.h>
#include <TLine.h>
#include <TArrow.h>
#include <TAxis.h>
#include <TMarker.h>
#include <TDirectory.h>
#include <TMap.h>
#include <TObject.h>
#include <TBuffer.h>
#include <TMemberInspector.h>
#include <TClass.h>
//---------------------- Pythia8
#include <Pythia.h>
//-----------------------

using namespace std;

typedef complex<double> dcomplex;
typedef complex<int> icomplex;

namespace Moses1 {

class commonOperations {
	public:
		commonOperations();
		~commonOperations();
		
		bool fileexists(string filename);
		void exitIfNotExist(string fullPath);
		// for creating one char from path+name
		string checkANDsetFilepath(string envPath, string fileName);
		bool checkPath(string envPath);
		void SetOKStyle();
		TH1D* Shift(TH1D* h, double x);
		void NormToBinWidth(TH1D* h);
		double Integral(TH1D* h);
		double IntegralOverFlow(TH1D* h);
		void Scale(TH1D* h, double d);
		void Norm(TH1D* h);
		void plot(TH1D* h);
		void relDiff(TH1D* hInput, TH1D* hReference, TH1D* hRelDiffPos, TH1D* hRelDiffNeg);

		double simpsonIntegration(double *yArray, double *xArray, int arraysSize, double startX, double endX);
		double simpsonIntegration(vector<double> &yVector, vector<double> &xVector, double startX, double endX);

	private:
		double simpsonIntegrationFunction(double *yArray, double *xArray, int arraysSize, double startX, double endX);
};

}
#endif
